﻿using UnityEngine;
using System.Collections;

public class playerMoviment : MonoBehaviour {
    //Player Defaults
    [SerializeField]
    public float playerSpeed = 0.1f;

    //Manipulate Animation
    Animator anim;
    string run = "speed";

    //Level's Limits
    [SerializeField]
    float limitX;
    float limitY;

    //Wall Limit
    float wallLimit = 4.1f;

    //Create the vector3 to be manipulated
    Vector3 actualPosition;

    // Use this for initialization
    void Start () {
        anim = GetComponent<Animator>();
        limitX -= transform.localScale.x / 2;
        limitY = Camera.main.orthographicSize;
        //Debug.Log(-Camera.main.orthographicSize + (transform.localScale.x));
    }
	
	// Update is called once per frame
	void FixedUpdate () {
        //Control's player moviment
        Movement();
        //Control's player animation
        ControlAnimation();
        //Contol's player limit on the level
        CameraLimit();

        //Replace the moviment to the position basead in the functions above
        transform.position = actualPosition;

    }

    void Movement() {
        //Define the atual position
        actualPosition = transform.position;

        //move the player horizontally based on the Axis
        actualPosition.x += Input.GetAxis("Horizontal") * playerSpeed;

        //move the player vertically based on the Axis
        actualPosition.y += Input.GetAxis("Vertical") * playerSpeed;

        
    }

    void ControlAnimation() {
        //Set the player force movement to animate the sprite
        if(playerSpeed != 0){ 
            anim.SetFloat(run, Mathf.Abs(Input.GetAxis("Horizontal") + Mathf.Abs(Input.GetAxis("Vertical"))));
        }

        //Flips the Player toward its direction
        if (Input.GetAxis("Horizontal") < 0) {
            transform.eulerAngles = new Vector2(0, 180);
        }
        if (Input.GetAxis("Horizontal") > 0) {
            transform.eulerAngles = new Vector2(0, 0);
        }
    }

    void CameraLimit() {
        //Control player movement X+ (RIGHT) 
        if(actualPosition.x > limitX) {
            actualPosition.x = limitX;
        }
        //Control player movement X+ (LEFT) 
        if (actualPosition.x < -limitX) {
            actualPosition.x = -limitX;
        }
        //Control player movement Y+ (UP) and include the wall limit
        if (actualPosition.y > limitY - wallLimit) {
            actualPosition.y = limitY - wallLimit;
        }
        //Control player movement Y+ (DOWN) and include the player 2 hp limit
        if (actualPosition.y < -limitY + 1.8f) {
            actualPosition.y = -limitY + 1.8f;
        }

    }
}
